config/routes.rb
Rails.application.routes.draw do
  root 'login#index'

  resources :login, only: [:index, :new]
  resources :users, only: [:new, :create]
  scope module: :admin do
    resources :addresses, only: [:index]
    resources :users, only: [:update]
    resources :registers, only: [:new, :create]
    resources :bills, only: [:new, :create]
    resources :prices, only: [:new, :create]
  end
  scope module: :logged do
    resources :readings, only: [:new, :create]
    resources :users, only: [:show] do
      get 'search', on: :collection
    end
  end
end

app/models/reading.rb
class Reading < ApplicationRecord
  belongs_to :register
  validates :kwh, presence: true, numericality: true
  validate :validate_kwh_is_greater_or_eq
  validate :validate_kwh_format

  scope :read_till, ->(date) { where('read_at <= ?', date) }

  private

  def validate_kwh_format
    decimals = register.register_decimals
    str_without_dec = '\\A\\d+\\.0\\z'
    str_with_dec = '\\A\\d+(?:\\.\\d{0,' + decimals.to_s + '})?\\z'
    regexp = decimals.positive? ? str_with_dec : str_without_dec

    (errors.add :kwh, (decimals.to_s + ' decimals expected, but got: ' + kwh.to_s)) if kwh.to_s !~ Regexp.new(regexp)
  end

  def validate_kwh_is_greater_or_eq
    gt_reading_register
    # stop validation if kwh is NULL or no record exists with greater value
    return if kwh.nil? || !self.class.where(@reading_kwh_gt).where(@register_by_id).exists?

    errors.add :kwh, ' must be greater or equals than the others stored in existing records'
  end

  def gt_reading_register
    @reading_kwh_gt = self.class.arel_table[:kwh].gt(kwh)
    @register_by_id = self.class.arel_table[:register_id].eq(register_id)
  end
end

app/controllers/logged/readings_controller.rb
module Logged
  class ReadingsController < SessionBaseController
    def new
      @reading = Reading.new(register: Register.find(params[:register_id]))
    rescue ActiveRecord::RecordNotFound
      redirect_to '/404'
    end

    def create
      @reading = Reading.new(reading_params)

      if @reading.save
        redirect_to back_from_level_two
      else
        render 'new'
      end
    end

    private

    def reading_params
      params.require(:reading).permit(:kwh, :read_at, :register_id)
    end
  end
end

app/controllers/logged/session_base_controller.rb
class SessionBaseController < UsersBaseController
  before_action :check_session_user

  def check_session_user
    redirect_to '/422' unless session?
  end
end

app/controllers/logged/users_controller.rb
module Logged
  class UsersController < SessionBaseController
    def show
      @user = User.find(params[:id])
    end

    def search
      @user = User.find_by(username: params[:username])

      if @user.nil?
        flash[:notice] = "User #{params[:username]} not found"
        redirect_to root_url
      else
        redirect_to @user
      end
    end
  end
end

app/views/logged/readings/_form.html.erb
<%= form_with model: reading, local: true do |reading_form| %>
    <%= render 'components/errors', object: reading %>
    
    <p>
	<%= reading_form.label :kwh %>
	<%= reading_form.text_field :kwh, value: (reading.register.readings.last.kwh.to_s(:rounded, precision: reading.register.register_decimals) if  reading.register.readings.any?) %>
    </p>
    <p>
	<%= reading_form.hidden_field :register_id, value: reading.register.id %>
    </p>
    <p>
	<%= reading_form.label :read_at %>
	<%= reading_form.text_field :read_at, value: Time.current, readonly: true %>
    </p>
    <p>
	<%= reading_form.submit %>
    </p>
    </tr>
<% end %>

app/views/logged/readings/new.html.erb
<h1>Create Reading</h1>

<%= render partial: 'form', locals: {reading: @reading} %>

<%= link_to 'Cancel', session[:username] == 'admin' ? addresses_url : search_users_path(username: session[:username]) %>